var LOGFILE_NAME = "sonos-controller.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};


lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

var Utf8 = {
		 
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	 
	        for (var n = 0; n < string.length; n++) {
	 
	            var c = string.charCodeAt(n);
	 
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	 
	        }
	 
	        return utftext;
	    },
	 
	    // public method for url decoding
	    decode : function (utftext) {
	        var string = "";
	        var i = 0;
	        var c = c1 = c2 = 0;
	 
	        while ( i < utftext.length ) {
	 
	            c = utftext.charCodeAt(i);
	 
	            if (c < 128) {
	                string += String.fromCharCode(c);
	                i++;
	            }
	            else if((c > 191) && (c < 224)) {
	                c2 = utftext.charCodeAt(i+1);
	                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	                i += 2;
	            }
	            else {
	                c2 = utftext.charCodeAt(i+1);
	                c3 = utftext.charCodeAt(i+2);
	                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	                i += 3;
	            }
	 
	        }
	 
	        return string;
	    }
	 
	};


function getLibraryPanic() {
	var Lang=Property.getProperty('/system/language/locale');
	return {restoreAfter:true,volume:50,type:'library',guid:'0d2c425a-857a-fa88-7511-19355415538a',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/0d2c425a-857a-fa88-7511-19355415538a.mp3'};
}
function getLibraryHail() {
	var Lang=Property.getProperty('/system/language/locale');
	switch (Lang) {
	case 'de_DE':
		return {restartAfter:true,volume:25,type:'library',guid:'ab5fb906-59f3-f3da-8190-bcf680c184ce',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/ab5fb906-59f3-f3da-8190-bcf680c184ce.mp3'};
	break;
	case 'fr_CH': 
		return {restartAfter:true,volume:25,type:'library',guid:'c5d42cb3-5e09-cc95-cbb7-03f214dd6cc6',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/c5d42cb3-5e09-cc95-cbb7-03f214dd6cc6.mp3'};
	break;
	case 'nl_NL':
		return {restartAfter:true,volume:25,type:'library',guid:'a25af6a9-272e-02de-a32e-004bf5d03a9c',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/a25af6a9-272e-02de-a32e-004bf5d03a9c.mp3'};
	break;
	case 'pl_PL': 
		return {restartAfter:true,volume:25,type:'library',guid:'1b1c9a9c-554d-55ed-e6a4-ea57e8b4fa1b',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/1b1c9a9c-554d-55ed-e6a4-ea57e8b4fa1b.mp3'};
	break;
	case 'tr_TR': 
		return {restartAfter:true,volume:25,type:'library',guid:'c884d6c3-f375-f4ab-32a1-c977b133bab2',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/c884d6c3-f375-f4ab-32a1-c977b133bab2.mp3'};
	break;
	default:
		return {restartAfter:true,volume:25,type:'library',guid:'ffc09a32-45fb-2492-4998-342c8e8c045e',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/ffc09a32-45fb-2492-4998-342c8e8c045e.mp3'};
}
	return {restartAfter:true,volume:25,type:'library',guid:'ffc09a32-45fb-2492-4998-342c8e8c045e',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/ffc09a32-45fb-2492-4998-342c8e8c045e.mp3'};
}
function getLibraryFire() {
	var Lang=Property.getProperty('/system/language/locale');	
	switch (Lang) {
		case 'de_DE':
			return {restoreAfter:true,volume:50,type:'library',guid:'ed520c04-803b-19f9-d6b9-05819134b60d',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/ed520c04-803b-19f9-d6b9-05819134b60d.mp3'};
		break;
		case 'fr_CH': 
			return {restoreAfter:true,volume:50,type:'library',guid:'32aa1a01-4833-e4c7-c7e0-ea55ef972f2a',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/32aa1a01-4833-e4c7-c7e0-ea55ef972f2a.mp3'};
		break;
		case 'nl_NL':
			return {restoreAfter:true,volume:50,type:'library',guid:'c6a40b67-5a31-8652-4f10-73c042029a15',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/c6a40b67-5a31-8652-4f10-73c042029a15.mp3'};
		break;
		case 'pl_PL': 
			return {restoreAfter:true,volume:50,type:'library',guid:'92006ecc-c718-9b14-5da5-7d98a4ecb416',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/92006ecc-c718-9b14-5da5-7d98a4ecb416.mp3'};
		break;
		case 'tr_TR': 
			return {restoreAfter:true,volume:50,type:'library',guid:'12be7cf0-7731-981a-4a44-99f8260a6d44',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/12be7cf0-7731-981a-4a44-99f8260a6d44.mp3'};
		break;
		default:
			return {restoreAfter:true,volume:50,type:'library',guid:'32c731e1-0171-a846-b291-de55bceeedfa',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/32c731e1-0171-a846-b291-de55bceeedfa.mp3'};
	}
	return {restoreAfter:true,volume:50,type:'library',guid:'32c731e1-0171-a846-b291-de55bceeedfa',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/32c731e1-0171-a846-b291-de55bceeedfa.mp3'};
}


Property.setSavedProperty=function (path,value) {
	  Property.setProperty(path, value);
	  Property.setFlag(path, 'ARCHIVE', true);
}

function decode(sString) {
	sString=unescape(sString);
	sString=sString.replace(/&amp;/g, '&');
	sString=sString.replace(/&lt;/g, '<');
	sString=sString.replace(/&gt;/g, '>');
	sString=sString.replace(/&quot;/g, '"');
	sString=sString.replace(/&apos;/g, "'");
	return sString;
}

function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function getNewTempIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('temp');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function dSID2dSUID(dSID) {
    try {
        //copy the first 6 bytes (12 characters to the new dsuid
        var dSUID = dSID.slice(0, 12);
        //insert 4 bytes of 0
        dSUID += '00000000';
        //append the remaining 6 bytes (12 chars) of the dsid
        dSUID += dSID.slice(12, 24);
        //finaly add 1 byte of 0
        dSUID += '00';
        return dSUID;
    } catch (e) {
        lWarn.logln('Exception in store-property-helper::dSID2dSUID ' + e);
        return '';
    }
}
function checkAndStoreIntParameter(path, value) {
    try 
    {
        lInfo.logln('store integer at |' + path + "| value: |" + value + "|" );
        var sucessCode = false;
        var intValue = parseInt("" + value);
        if (!isNaN(intValue)) {
        	Property.setSavedProperty(path, intValue);
            sucessCode = true;
        } else {
            lWarn.logln("Typ-Fehler beim Speichern der Property entries/" + path);
        }
        return sucessCode;
    }
    catch (e)
    {
        lWarn.logln("Exception beim checkAndStoreIntParameter " + e + " Path " + path  + " value " + value);
        return false;
    }        
}

function checkAndStoreStringParameter(path, value) {
    try 
    {
        lInfo.logln('store string at |' + path + "| value: |" + value + "|" );
        var sucessCode = false;
        var stringValue = (typeof(value) === "number") ? String(value) : value;
        if (typeof(stringValue) === "string") {
        	Property.setSavedProperty(path, stringValue);
            sucessCode = true;
        } else {
            lWarn.logln("Typ-Fehler beim Speichern der Property entries/" + path);
        }
        return sucessCode;
    }
    catch (e)
    {
        lWarn.logln("Exception beim checkAndStoreStringParameter " + e + " Path " + path  + " value " + value);
        return false;
    }        
}

function checkAndStoreDSUIDParameter(path, dsuid, dsid) {
    try 
    {
        lInfo.logln('store dsuid at |' + path + "| value: |" + dsuid + "|" );
        var successCode = false;
        var stringValue;
        if (typeof(dsuid) === 'string') {
        	Property.setSavedProperty(path, dsuid);
            successCode = true;
        } else {
            if (typeof(dsid) === 'string') {
                stringValue = dSID2dSUID(dsid);
                if (typeof(stringValue) === "string") {
                	Property.setSavedProperty(path, stringValue);
                    successCode = true;
                }                
                lInfo.logln("store converted dsid");
            } else {
                lWarn.logln('Typ-Fehler beim Speichern der Property entries/' + path)
            }
        }
        return successCode;
    }
    catch (e)
    {
        lWarn.logln("Exception beim checkAndStoreDSUIDParameter " + e + " Path " + path  + " value " + dsuid);
        return false;
    }        
}

function checkAndStoreBoolParameter(path, value) {
    try 
    {
        lInfo.logln('store boolean at |' + path + "| value: |" + value + "|" );
        var successCode = false;
        var boolValue = false;
        if (typeof(value) === "boolean") {
        	Property.setSavedProperty( path, value);
            successCode = true;
        } else {
            if (typeof(value) === "string") {
                if (value === "true") {
                    boolValue = true;
                }
                Property.setSavedProperty( path, boolValue);
                successCode = true;
            } else {
                lWarn.logln("Typ-Fehler beim Speichern der Property entries/" + path);
            }
        }
        return successCode;
    }
    catch (e)
    {
        lWarn.logln("Exception beim checkAndStoreBoolParameter " + e + " Path " + path  + " value " + value);
        return false;
    }        
}

function putConditionParameter(idValue,oParameterObject) {
	var succeded = true;
	if (oParameterObject.conditions==null)
		return succeded;
	var sSubpath=idValue + '/conditions/';
	if (oParameterObject.conditions.enabled!=null) {
		if (oParameterObject.conditions.enabled==true)
			Property.setSavedProperty(sSubpath + 'enabled', true);
		else 
			Property.setSavedProperty(sSubpath + 'enabled', false);
	}	
	if (oParameterObject.conditions.weekdays!=null) {
		var sString="";
		for (var iIndex=0;iIndex<oParameterObject.conditions.weekdays.length;iIndex++) {
			var sWeekday=oParameterObject.conditions.weekdays[iIndex];
			switch (sWeekday)
			{
				case 'SU':
					sString += '0,';
				break;
				case 'MO':
					sString += '1,';
				break;
				case 'TU':
					sString += '2,';
				break;
				case 'WE':
					sString += '3,';
				break;
				case 'TH':
					sString += '4,';
				break;
				case 'FR':
					sString += '5,';
				break;
				case 'SA':
					sString += '6,';
				break;
			}	
		}
		if (sString!="") {
			sString=sString.substr(0,sString.length-1);
			Property.setSavedProperty(sSubpath + 'weekdays', sString);
		}
	}	
	if (oParameterObject.conditions.systemState!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.systemState.length;iIndex++){
			var sStateName=oParameterObject.conditions.systemState[iIndex].name;
			var sStateValue=oParameterObject.conditions.systemState[iIndex].value;
			if (sStateValue==='false')
				sStateValue=false;
			if (sStateValue==='true')
				sStateValue=true;
			Property.setSavedProperty(sSubpath + 'states/' + sStateName,sStateValue);
		}
	}	
	if (oParameterObject.conditions.addonStates!=null) {
		for (var sAddonId in oParameterObject.conditions.addonStates) {
			for (var iIndex=0;iIndex<oParameterObject.conditions.addonStates[sAddonId].length;iIndex++){
				var sStateName=oParameterObject.conditions.addonStates[sAddonId][iIndex].name;
				var sStateValue=oParameterObject.conditions.addonStates[sAddonId][iIndex].value;
				if (sStateValue==='false')
					sStateValue=2;
				if (sStateValue==='true')
					sStateValue=1;
				if (sStateValue===false)
					sStateValue=2;
				if (sStateValue===true)
					sStateValue=1;
				Property.setSavedProperty(sSubpath + 'addon-states/' + sAddonId + '/' + sStateName,sStateValue);
			}
		}
	}	
	if (oParameterObject.conditions.zoneState!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.zoneState.length;iIndex++){ 
			var zoneID=oParameterObject.conditions.zoneState[iIndex].zone;
			var groupID=oParameterObject.conditions.zoneState[iIndex].group;
			var sceneID=oParameterObject.conditions.zoneState[iIndex].scene;
			
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/zone' , zoneID) ? succeded : false;
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/group' , groupID) ? succeded : false;
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/scene' , sceneID) ? succeded : false;
		}
	}	
	if (oParameterObject.conditions.timeframe!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.timeframe.length;iIndex++){ 
			var from=oParameterObject.conditions.timeframe[iIndex].start;
			var to=oParameterObject.conditions.timeframe[iIndex].end;
			var sFromBase=from.timeBase;
			var sFromOffset=from.offset;
			var sToBase=to.timeBase;
			var sToOffset=to.offset;
			lInfo.logln('from ' + sFromBase + ' off ' + sFromOffset + ' to  ' + sToBase + ' off ' + sToOffset);
			if (sFromBase=='daily')
				if (sToBase=='daily'){
					Property.setSavedProperty(sSubpath + 'time-start' , Math.floor(parseInt("" + sFromOffset,10)/3600) + ':' + Math.floor(parseInt("" + sFromOffset,10)/60)%60 + ':' + Math.floor(parseInt("" + sFromOffset,10)%60));
					Property.setSavedProperty(sSubpath + 'time-end'  , Math.floor(parseInt("" + sToOffset,10)/3600) + ':' + Math.floor(parseInt("" + sToOffset,10)/60)%60 + ':' + Math.floor(parseInt("" + sToOffset,10)%60));
				}
		}	
	}		
	return succeded;
}

function putTriggerParameter(idValue,oParameterObject) {
	var succeded = true;
	var iIndex;
    for (iIndex=0;iIndex<oParameterObject.triggers.length;iIndex++)
    {
        var sSubpath=idValue + '/triggers/' + (iIndex + 1) + "/";
        switch(oParameterObject.triggers[iIndex].type) {       
	        case 'bus-zone-scene':
	        case 'zone-scene':
	        	var triggerName='bus-zone-scene';
	        	
	        		if (oParameterObject.triggers[iIndex].scene==5)
	        			triggerName='zone-scene';
	        		if (oParameterObject.triggers[iIndex].scene==17)
	        			triggerName='zone-scene';
	        		if (oParameterObject.triggers[iIndex].scene==18)
	        			triggerName='zone-scene';
	        		if (oParameterObject.triggers[iIndex].scene==19)
	        			triggerName='zone-scene';
	        		
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , triggerName) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "zone" , oParameterObject.triggers[iIndex].zone) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "group" , oParameterObject.triggers[iIndex].group) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene) ? succeded : false;
                if (oParameterObject.triggers[iIndex].forced!=null)
                	succeded = checkAndStoreBoolParameter(sSubpath + "forced" , oParameterObject.triggers[iIndex].forced) ? succeded : false;
                Property.setSavedProperty(sSubpath + "dsuid" , -1);
                break;
            case 'undo-zone-scene':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "zone" , oParameterObject.triggers[iIndex].zone) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "group" , oParameterObject.triggers[iIndex].group) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene) ? succeded : false;
            	Property.setSavedProperty(sSubpath + "dsid" , -1);
                break;
            case 'device-msg':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(sSubpath + "dsuid" , oParameterObject.triggers[iIndex].dsuid, oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "msg" , oParameterObject.triggers[iIndex].msg) ? succeded : false;
                if (oParameterObject.triggers[iIndex].buttonIndex!=null)
                	succeded = checkAndStoreIntParameter(sSubpath + "buttonIndex" , oParameterObject.triggers[iIndex].buttonIndex) ? succeded : false;
                break;
            case 'device-binary-input':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "index" , oParameterObject.triggers[iIndex].index) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "state" , oParameterObject.triggers[iIndex].state) ? succeded : false;
                break;
            case 'device-scene':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(sSubpath + "dsuid" , oParameterObject.triggers[iIndex].dsuid, oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene) ? succeded : false;
                break;
            case 'custom-event':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "event" , oParameterObject.triggers[iIndex].event) ? succeded : false;
                break;
            case 'device-sensor':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(sSubpath + "dsuid" , oParameterObject.triggers[iIndex].dsuid, oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "eventid" , oParameterObject.triggers[iIndex].eventid) ? succeded : false;
                break;
            case 'state-change':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "name" , oParameterObject.triggers[iIndex].name) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "state" , oParameterObject.triggers[iIndex].state) ? succeded : false;
                break;
            case 'addon-state-change':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "addon-id" , oParameterObject.triggers[iIndex].addonId) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "name" , oParameterObject.triggers[iIndex].name) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "state" , oParameterObject.triggers[iIndex].state) ? succeded : false;
                break;
        }
    }
    return succeded;
}

function putActionParameter(idValue,oParameterObject) {
	var succeded = true;
	var sSubpath=idValue + '/action/';
	
	succeded = checkAndStoreStringParameter(sSubpath+"type",oParameterObject.action.type) ? succeded : false; /*command,library,text2speech,favorite,playlist,plainSong,plainRadio,plainQueue*/
	if (oParameterObject.action.type=='favorite') {
		if (oParameterObject.action.contentSrc!=null)
			succeded = checkAndStoreStringParameter(sSubpath+"contentSrc",oParameterObject.action.contentSrc) ? succeded : false;
		if (oParameterObject.action.metaData!=null)
			succeded = checkAndStoreStringParameter(sSubpath+"metaData",Utf8.encode(decode(oParameterObject.action.metaData))) ? succeded : false;		

	} else if (oParameterObject.action.type=='playlist') {
		if (oParameterObject.action.contentSrc!=null)
			succeded = checkAndStoreStringParameter(sSubpath+"contentSrc",decode(oParameterObject.action.contentSrc)) ? succeded : false;
		if (oParameterObject.action.metaData!=null)
			succeded = checkAndStoreStringParameter(sSubpath+"metaData",Utf8.encode(decode(oParameterObject.action.metaData))) ? succeded : false;		
		
	} else if (oParameterObject.action.type=='plainSong') {
		if (oParameterObject.action.contentSrc!=null)
			succeded = checkAndStoreStringParameter(sSubpath+"contentSrc",Utf8.encode(decode(oParameterObject.action.contentSrc))) ? succeded : false;
		if (oParameterObject.action.metaData!=null)
			succeded = checkAndStoreStringParameter(sSubpath+"metaData",Utf8.encode(oParameterObject.action.metaData)) ? succeded : false;		
		if (oParameterObject.action.info!=null) {
			for (var sKey in oParameterObject.action.info) {
				succeded = checkAndStoreStringParameter(sSubpath+"info/" + sKey,Utf8.encode(decode(oParameterObject.action.info[sKey]))) ? succeded : false;
			}
		}
	} else if (oParameterObject.action.type=='plainRadio') {
		if (oParameterObject.action.contentSrc!=null)
			succeded = checkAndStoreStringParameter(sSubpath+"contentSrc",decode(oParameterObject.action.contentSrc)) ? succeded : false;
		if (oParameterObject.action.metaData!=null)
			succeded = checkAndStoreStringParameter(sSubpath+"metaData",Utf8.encode(oParameterObject.action.metaData)) ? succeded : false;		
		if (oParameterObject.action.info!=null) {
			for (var sKey in oParameterObject.action.info) {
				succeded = checkAndStoreStringParameter(sSubpath+"info/" + sKey,Utf8.encode(oParameterObject.action.info[sKey])) ? succeded : false;
			}
		}
	} else if (oParameterObject.action.type=='plainQueue') {
		for (var iIndex=0;iIndex<oParameterObject.action.content.length;iIndex++) {
			succeded = checkAndStoreStringParameter(sSubpath+"queue/"+iIndex+"/contentSrc",decode(oParameterObject.action.content[iIndex].contentUrl)) ? succeded : false;
			succeded = checkAndStoreStringParameter(sSubpath+"queue/"+iIndex+"/title" ,Utf8.encode(oParameterObject.action.content[iIndex].title)) ? succeded : false;
			succeded = checkAndStoreStringParameter(sSubpath+"queue/"+iIndex+"/pos",oParameterObject.action.content[iIndex].pos) ? succeded : false;
		}
	} else if (oParameterObject.action.type=='library') {
		succeded = checkAndStoreStringParameter(sSubpath+"contentSrc",decode(oParameterObject.action.contentSrc)) ? succeded : false;
		succeded = checkAndStoreStringParameter(sSubpath+"guid",oParameterObject.action.guid) ? succeded : false;		
	} else if (oParameterObject.action.type=='text2speech') {
		
		if (oParameterObject.action.contentSrc==null)
			succeded = checkAndStoreStringParameter(sSubpath+"contentSrc",decode(raisedEvent.parameter.contentSrc)) ? succeded : false;
		else
			succeded = checkAndStoreStringParameter(sSubpath+"contentSrc",decode(oParameterObject.action.contentSrc)) ? succeded : false;
		
		if (oParameterObject.action.guid==null)
			succeded = checkAndStoreStringParameter(sSubpath+"guid",raisedEvent.parameter.guid) ? succeded : false;						
		else
			succeded = checkAndStoreStringParameter(sSubpath+"guid",oParameterObject.action.guid) ? succeded : false;	
		
		succeded = checkAndStoreStringParameter(sSubpath+"info/voice_id",oParameterObject.action.voice_id) ? succeded : false;						
		succeded = checkAndStoreStringParameter(sSubpath+"info/text",escape(oParameterObject.action.text)) ? succeded : false;	
	} else if (oParameterObject.action.type=='command') { 
		succeded = checkAndStoreStringParameter(sSubpath+"command",oParameterObject.action.command) ? succeded : false;
	}
		
	if (oParameterObject.action.volume!=null)
		succeded = checkAndStoreIntParameter(sSubpath+"volume",oParameterObject.action.volume) ? succeded : false;
	if (oParameterObject.action.loopingTimespan!=null)
		succeded = checkAndStoreIntParameter(sSubpath+"loopingTimespan",oParameterObject.action.loopingTimespan) ? succeded : false;

	if (oParameterObject.action.restoreAfter!=null)
		succeded = checkAndStoreBoolParameter(sSubpath+"restoreAfter",oParameterObject.action.restoreAfter) ? succeded : false;	
	
	if (oParameterObject.action.restartAfter!=null) {
		succeded = checkAndStoreBoolParameter(sSubpath+"restartAfter",oParameterObject.action.restartAfter) ? succeded : false;
		
		if (oParameterObject.action.restartAfter==true)
			succeded = checkAndStoreBoolParameter(sSubpath+"restoreAfter",true) ? succeded : false;	
	}

	if (oParameterObject.action.maxDuration!=null)
		succeded = checkAndStoreIntParameter(sSubpath+"maxDuration",oParameterObject.action.maxDuration) ? succeded : false;	

	return succeded;
}

function putTargetParameter(idValue,oParameterObject) {
	var succeded=true;
	var sSubpath=idValue + '/target/';
	if (oParameterObject.target==null)
		return false;
	if (oParameterObject.target.grouped) {
		if (oParameterObject.target.grouped.length==0)
			return false;
		for (var iIndex=0;iIndex<oParameterObject.target.grouped.length;iIndex++)
			succeded = checkAndStoreIntParameter(sSubpath+"grouped/" + iIndex,oParameterObject.target.grouped[iIndex]) ? succeded : false;
	}
	if (oParameterObject.target.singularyZone) {
		if (oParameterObject.target.singularyZone.length==0)
			return false;
		for (var iIndex=0;iIndex<oParameterObject.target.singularyZone.length;iIndex++)
			succeded = checkAndStoreIntParameter(sSubpath+"singularyZone/" + iIndex,oParameterObject.target.singularyZone[iIndex]) ? succeded : false;
	}
	return succeded;
}

function storeTemporaryValue(sValue) {
    try {
        var oParameterObject = JSON.parse(decode(sValue));

        
        var baseNode = Property.getNode('/scripts/sonos-controller');
        if (baseNode != null) {
            baseNode.removeChild('temp');
        }
        Property.setSavedProperty('temp/id', 0);
        
        if (!putActionParameter('temp' ,oParameterObject)) throw "wrong argument types";
        if (!putTargetParameter('temp',oParameterObject)) throw "wrong argument types";
        if (oParameterObject.metaData!=null) 
        	Property.setSavedProperty('temp/metaData',oParameterObject.metaData);
        return 'temp';
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
        	lWarn.logln(i + ': ' + e[i]);
        }
        //we could not store all data successfully so we cleanup
        var baseNode = Property.getNode('/scripts/sonos-controller');
        if (baseNode != null) {
            baseNode.removeChild('temp');
        }
        return null;
    }
}

function makeImplicitEntry(oValue) {
	var iIndex;
	var oTriggerObject=[];
	
    for (iIndex=0;iIndex<oValue.triggers.length;iIndex++)
    {
        switch(oValue.triggers[iIndex].type) {
        	case 'bus-zone-scene':
        	case 'zone-scene':
        		if (oValue.triggers[iIndex].zone==0)
            		if (oValue.triggers[iIndex].group==0) {
            			oTriggerObject.push({
            				type:'undo-zone-scene',
            				zone:0,
            				group:0,
            				scene:oValue.triggers[iIndex].scene
            			});
            		}
        	break;
        	case 'state-change':
        		oTriggerObject.push({
    				type:'state-change',
    				name:oValue.triggers[iIndex].name,
    				state:(oValue.triggers[iIndex].state=='active')?'inactive':'active'
    			});
        	break;
        	default:
        		lInfo.logln('dont know what to do with this trigger');
        	break;
        }
    }
    if (oTriggerObject.length==0) {
    	lInfo.logln('no implicit restore trigger needed');
    	return;
    }
    lInfo.logln('should add a trigger with ' + JSON.stringify(oTriggerObject));
    
    var fFound=false;
    var iMaxIndex=0;
    if (Property.getNode('restoreStatus/triggers')!=null){
    	var oArray=Property.getNode('restoreStatus/triggers').getChildren();
    	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
    		var oNode=oArray[iIndex]
    		var iName=parseInt(oNode.getName(),10);
    		if (iName>=iMaxIndex)
    			iMaxIndex=iName+1;
    		var fMaybe=true;
    		for (var jIndex=0;jIndex<oTriggerObject.length;jIndex++) {
    			for (var sKey in oTriggerObject[jIndex]) {
    				if (oNode.getChild(sKey)!=null)
    					if (oNode.getChild(sKey).getValue()!=oTriggerObject[jIndex][sKey])
    						fMaybe=false;
    			}
    		}
    		if (fMaybe)
    			fFound=true;
    	}	
    }
    if (!fFound) {
    	lInfo.logln('restore trigger not found, adding this entry');
		for (var jIndex=0;jIndex<oTriggerObject.length;jIndex++) {
			for (var sKey in oTriggerObject[jIndex]) {
				Property.setSavedProperty('restoreStatus/triggers/' + iMaxIndex + '/'  +sKey,oTriggerObject[jIndex][sKey]);
			}
			iMaxIndex++;
		}
    	
    } else  {
    	lInfo.logln('trigger allready there');
    }
    var fRegisterTrigger=false;
    if (Property.getNode('/usr/triggers')!=null) {
		var oTriggerArray=Property.getNode('/usr/triggers').getChildren();
		for (var iIndex=0;iIndex<oTriggerArray.length;iIndex++) {
			if (oTriggerArray[iIndex].getChild('triggerPath').getValue()=='/scripts/sonos-controller/restoreStatus')
				fRegisterTrigger=true;
		}
	}
	if (!fRegisterTrigger) 
		registerTrigger('/scripts/sonos-controller/restoreStatus','sonos.execute.special',{actions:'restoreActualStatusAndGrouping'});


}

function storeValue(sValue) {
    try {
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        
        if (oParameterObject.id != null) {
        	idValue = oParameterObject.id;  
        	unregisterTrigger('entries/' + idValue);
        } else {
            idValue = getNewIdValue();
        }
        
        var baseNode = Property.getNode('entries');
        if (baseNode != null) {
            baseNode.removeChild(idValue);
        }
        Property.setSavedProperty('entries/' + idValue + '/id', idValue);
        Property.setSavedProperty('entries/' + idValue + '/conditions/enabled', true);

        if (!putActionParameter('entries/' + idValue,oParameterObject)) throw "wrong argument types";
        if (!putTargetParameter('entries/' + idValue,oParameterObject)) throw "wrong argument types";
        if (!putTriggerParameter('entries/' + idValue,oParameterObject)) throw "wrong argument types";
        if (!putConditionParameter('entries/' + idValue,oParameterObject)) throw "wrong argument types";
        if (oParameterObject.metaData!=null) 
        	Property.setSavedProperty('entries/' + idValue + '/metaData',decode(oParameterObject.metaData));
        registerTrigger('/scripts/sonos-controller/entries/' + idValue,'sonos.execute',{});
        
        
        if (oParameterObject.implicitRestore!=null) {
        	if (oParameterObject.implicitRestore)
        		makeImplicitEntry(oParameterObject);
        	Property.setSavedProperty('entries/' + idValue + '/implicitRestore',oParameterObject.implicitRestore);
        }
        
        return true;
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
        	lWarn.logln(i + ': ' + e[i]);
        }
        //we could not store all data successfully so we cleanup
        Property.getNode('entries').removeChild(idValue);
        return false;
    }
} 

function ensurePredefinedEntryForZone(zoneID) {
	lInfo.logln('ensure predefined trigger for zone ' + zoneID);
	var oStartScenes=[5,33,35,37,39];
	var oStopScenes=[0,32,34,36,38];
	var oZoneStopScene=[68,67];
	var fStartScene=false;
	var fStopScene=false;
	if (Property.getNode('entries')!=null) {
		var entryArray=Property.getNode('entries').getChildren();
		for (var iIndex=0;iIndex<entryArray.length;iIndex++) {
			var baseEntry=entryArray[iIndex];
			if (baseEntry.getChild('metaData')!=null)
				if (baseEntry.getChild('metaData').getValue()!='') {
					var oVal=JSON.parse(baseEntry.getChild('metaData').getValue());
					if (oVal.type!=null)
						if (oVal.zone!=null) {
							if (oVal.type=='predefinedStopEntry')
								if (oVal.zone==zoneID)
									fStopScene=true;
							if (oVal.type=='predefinedStartEntry')
								if (oVal.zone==zoneID)
									fStartScene=true;
						}
	
			}
			if (fStartScene && fStopScene) {
				lInfo.logln('predefined trigger for zone ' + zoneID + ' allready existent');
				return;
			}		
		}
	}
	var oParameterPause={
			metaData:'{"zone":'+zoneID+',"type":"predefinedStopEntry"}',
			triggers:[],
			action:{type:'command',command:'pause'},
			target:{singularyZone:[zoneID]}
		};
	var oParameterStart={
			metaData:'{"zone":'+zoneID+',"type":"predefinedStartEntry"}',
			triggers:[],
			action:{type:'command',command:'play'},
			target:{singularyZone:[zoneID]}
		};
	for (var iIndex=0;iIndex<oStopScenes.length;iIndex++) {
		oParameterPause.triggers.push({
			type:'bus-zone-scene',
			zone:zoneID,
			group:4,
			scene:oStopScenes[iIndex]				
		});
		oParameterPause.triggers.push({
			type:'bus-zone-scene',
			zone:zoneID,
			group:0,
			scene:oStopScenes[iIndex]				
		});
		oParameterPause.triggers.push({
			type:'bus-zone-scene',
			zone:0,
			group:4,
			scene:oStopScenes[iIndex]				
		});
		oParameterPause.triggers.push({
			type:'bus-zone-scene',
			zone:0,
			group:0,
			scene:oStopScenes[iIndex]				
		});
	}
	for (var iIndex=0;iIndex<oZoneStopScene.length;iIndex++) {
		oParameterPause.triggers.push({
			type:'bus-zone-scene',
			zone:zoneID,
			group:0,
			scene:oZoneStopScene[iIndex]				
		});
	}
	for (var iIndex=0;iIndex<oStartScenes.length;iIndex++) {
		oParameterStart.triggers.push({
			type:'zone-scene',
			zone:zoneID,
			group:4,
			scene:oStartScenes[iIndex]				
		});
		oParameterStart.triggers.push({
			type:'zone-scene',
			zone:zoneID,
			group:0,
			scene:oStartScenes[iIndex]				
		});
		oParameterStart.triggers.push({
			type:'zone-scene',
			zone:0,
			group:4,
			scene:oStartScenes[iIndex]				
		});
		oParameterStart.triggers.push({
			type:'zone-scene',
			zone:0,
			group:0,
			scene:oStartScenes[iIndex]				
		});
	}
	storeValue(JSON.stringify(oParameterPause));
	storeValue(JSON.stringify(oParameterStart));
	lInfo.logln('predefined trigger for zone ' + zoneID + ' added');
}

function ensureDoorbell() {	
	if (Property.getNode('entries')!=null) {
		var entryArray=Property.getNode('entries').getChildren();
		for (var iIndex=0;iIndex<entryArray.length;iIndex++) {
			var baseEntry=entryArray[iIndex];
			if (baseEntry.getChild('metaData')!=null) 
				if (baseEntry.getChild('metaData').getValue()!='') {
					var oVal=JSON.parse(baseEntry.getChild('metaData').getValue());
					if (oVal.type!=null)
						if (oVal.type=='predefinedDoorbell')
							return;
		
				}
		}	
	}
	var oParameter={
			metaData:'{"type":"predefinedDoorbell"}',
			triggers:[{
				type:'bus-zone-scene',
				zone:0,
				group:0,
				scene:73				
			}],
			action:{restartAfter:true,volume:40,type:'library',guid:'8b785dbf-04e3-ee66-2dda-9593e2a20a48',contentSrc:'https://dsmedialibrary.blob.core.windows.net/library/8b785dbf-04e3-ee66-2dda-9593e2a20a48.mp3'},
			target:{grouped:[0]}
		};
	storeValue(JSON.stringify(oParameter));
}

function ensureFireAlert() {	
	if (Property.getNode('entries')!=null) {
		var entryArray=Property.getNode('entries').getChildren();
		for (var iIndex=0;iIndex<entryArray.length;iIndex++) {
			var baseEntry=entryArray[iIndex];
			if (baseEntry.getChild('metaData')!=null) 
				if (baseEntry.getChild('metaData').getValue()!='') {
					var oVal=JSON.parse(baseEntry.getChild('metaData').getValue());
					if (oVal.type!=null)
						if (oVal.type=='predefinedFire')
							return;
		
				}
		}
	}	
	var oParameterStart={
			metaData:'{"type":"predefinedFire"}',
			triggers:[{
				type:'state-change',
				name:'fire',
				state:'active'			
			}],
			action:getLibraryFire(),
			target:{grouped:[0]},
			implicitRestore:true
		};
	storeValue(JSON.stringify(oParameterStart));
}

function ensureHailAlert() {
	if (Property.getNode('entries')!=null) {
		var entryArray=Property.getNode('entries').getChildren();
		for (var iIndex=0;iIndex<entryArray.length;iIndex++) {
			var baseEntry=entryArray[iIndex];
			if (baseEntry.getChild('metaData')!=null) 
				if (baseEntry.getChild('metaData').getValue()!='') {
					var oVal=JSON.parse(baseEntry.getChild('metaData').getValue());
					if (oVal.type!=null)
						if (oVal.type=='predefinedHail')
							return;
		
				}
		}
	}
	var oParameterStart={
			metaData:'{"type":"predefinedHail"}',
			triggers:[{
				type:'state-change',
				name:'hail',
				state:'active'				
			}],
			action:getLibraryHail(),
			target:{grouped:[0]}
		};
	storeValue(JSON.stringify(oParameterStart));
	var oParameterStop={
			metaData:'{"type":"predefinedHail","visibility":false}',
			triggers:[{
				type:'state-change',
				name:'hail',
				state:'inactive'				
			}],
			action:{type:'command',command:'stop'},
			target:{singularyZone:[0]}
		};
	storeValue(JSON.stringify(oParameterStop));
}

function ensureAbsent() {
	if (Property.getNode('entries')!=null) {
		var entryArray=Property.getNode('entries').getChildren();
		for (var iIndex=0;iIndex<entryArray.length;iIndex++) {
			var baseEntry=entryArray[iIndex];
			if (baseEntry.getChild('metaData')!=null)
				if (baseEntry.getChild('metaData').getValue()!='') {
					var oVal=JSON.parse(baseEntry.getChild('metaData').getValue());
					if (oVal.type!=null)
						if (oVal.type=='predefinedAbsent')
							return;
		
				}
		}	
	}
	var oParameterStart={
			metaData:'{"type":"predefinedAbsent"}',
			triggers:[{
				type:'bus-zone-scene',
				zone:0,
				group:0,
				scene:72				
			}],
			action:{type:'command',command:'stop'},
			target:{singularyZone:[0]}
		};
	storeValue(JSON.stringify(oParameterStart));
}

function ensurePanic() {
	if (Property.getNode('entries')!=null) {
		var entryArray=Property.getNode('entries').getChildren();
		for (var iIndex=0;iIndex<entryArray.length;iIndex++) {
			var baseEntry=entryArray[iIndex];
			if (baseEntry.getChild('metaData')!=null) 
				if (baseEntry.getChild('metaData').getValue()!='') {
					var oVal=JSON.parse(baseEntry.getChild('metaData').getValue());
					if (oVal.type!=null)
						if (oVal.type=='predefinedPanic')
							return;
		
				}
		}
	}
	var oParameterStart={
			metaData:'{"type":"predefinedPanic"}',
			triggers:[{
				type:'zone-scene',
				zone:0,
				group:0,
				scene:65				
			}],
			action:getLibraryPanic(),
			target:{grouped:[0]},
			implicitRestore:true
		};
	storeValue(JSON.stringify(oParameterStart));
}

function ensureVolumeCommands(zoneID) {
	/*
	 * eventName:sonos.volume
	 * triggers
	 */
	if (Property.getNode('special/volumeTriggers')==null) {
		Property.setSavedProperty('special/volumeTriggers/eventName','sonos.volume');
	}
	var fTriggerExists=false;
	if (Property.getNode('special/volumeTriggers/triggers')!=null) {
		var oTriggerArray=Property.getNode('special/volumeTriggers/triggers').getChildren();
		for (var iIndex=0;iIndex<oTriggerArray.length;iIndex++) {
			if (oTriggerArray[iIndex].getChild('zone').getValue()==zoneID)
				fTriggerExists=true;
		}
	}
	if (!fTriggerExists) {
		lInfo.logln('adding a volumetrigger for ' + zoneID);
		Property.setSavedProperty('special/volumeTriggers/triggers/' + zoneID + '-inc/type','bus-zone-scene');
		Property.setSavedProperty('special/volumeTriggers/triggers/' + zoneID + '-inc/zone',parseInt(''+zoneID,10));
		Property.setSavedProperty('special/volumeTriggers/triggers/' + zoneID + '-inc/group',4);
		Property.setSavedProperty('special/volumeTriggers/triggers/' + zoneID + '-inc/scene',12);
		Property.setSavedProperty('special/volumeTriggers/triggers/' + zoneID + '-dec/type','bus-zone-scene');
		Property.setSavedProperty('special/volumeTriggers/triggers/' + zoneID + '-dec/zone',parseInt(''+zoneID,10));
		Property.setSavedProperty('special/volumeTriggers/triggers/' + zoneID + '-dec/group',4);
		Property.setSavedProperty('special/volumeTriggers/triggers/' + zoneID + '-dec/scene',11);
	}
	var fRegisterTrigger=false;
	if (Property.getNode('/usr/triggers')!=null) {
		var oTriggerArray=Property.getNode('/usr/triggers').getChildren();
		for (var iIndex=0;iIndex<oTriggerArray.length;iIndex++) {
			if (oTriggerArray[iIndex].getChild('triggerPath').getValue()=='/scripts/sonos-controller/special/volumeTriggers')
				fRegisterTrigger=true;
		}
	}
	if (!fRegisterTrigger) 
		registerTrigger('/scripts/sonos-controller/special/volumeTriggers','sonos.volume',{});
}

function ensurePredefinedEntries() {
	if (Property.getNode('players')==null)
		return;
	var oZoneArray=[];
	lInfo.logln('------------------------- ensurePredefinedEntries --------------');
	if (Property.getNode('special/volumeTriggers')!=null) {
		Property.getNode('special').removeChild('volumeTriggers');
	}
	
	ensureNoInactiveEntries();	
	
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var iIndex=0;iIndex<oPlayerArray.length;iIndex++)
		if (oPlayerArray[iIndex].getChild('zoneID')!=null) {
			var zoneID=oPlayerArray[iIndex].getChild('zoneID').getValue();
			if (zoneID!=0) {			
				ensurePredefinedEntryForZone(zoneID);
				ensureVolumeCommands(zoneID);
			}
		}
	ensureDoorbell();
	ensureFireAlert();
	ensureHailAlert();
	ensureAbsent();
	ensurePanic();
	Property.store();
}

function ensureNoInactiveEntries() {
	var oZoneArray=[];
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var iIndex=0;iIndex<oPlayerArray.length;iIndex++)
		if (oPlayerArray[iIndex].getChild('zoneID')!=null) {
			var zoneID=oPlayerArray[iIndex].getChild('zoneID').getValue();
			if (zoneID!=0) {
				oZoneArray.push(parseInt('' + zoneID,10));
			}
		}
	lInfo.logln(' --------- Entries should be not removes for zone: ' + oZoneArray);
	var oEntriesToRemove=[];
	if (Property.getNode('entries')!=null) {
		var entryArray=Property.getNode('entries').getChildren();
		for (var iIndex=0;iIndex<entryArray.length;iIndex++) {
			var baseEntry=entryArray[iIndex];
			if (baseEntry.getChild('metaData')!=null)
				if (baseEntry.getChild('metaData').getValue()!='') {
					var oVal=JSON.parse(baseEntry.getChild('metaData').getValue());
					if (oVal.type!=null)
						if (oVal.zone!=null) {
							if (oVal.type=='predefinedStopEntry'){
								lInfo.logln(' try zone ' + oVal.zone);
								if (oZoneArray.indexOf(parseInt('' + oVal.zone,10))==-1)
									oEntriesToRemove.push(baseEntry.getChild('id').getValue());
							}
							if (oVal.type=='predefinedStartEntry'){
								if (oZoneArray.indexOf(parseInt('' + oVal.zone,10))==-1)
									oEntriesToRemove.push(baseEntry.getChild('id').getValue());
							}
						}
			}
		}
	}
	lInfo.logln(' --------- Entries should be removed: ' + oEntriesToRemove);
	new Event('sonos.config',{actions:'delete',id:JSON.stringify(oEntriesToRemove)}).raise();
}

/*
 * execute Element: 
 * /triggers
 * /conditions
 * /target
 * /target/singularyZone: '[]'
 * /target/grouped: '[]'
 * /action
 * /action/contentSrc
 * /action/metaData
 * /action/volume
 * /action/loopingTimespan
 * /action/restartOld
 * /action/command
 * /metaData
 * */

function relayedIfText2SpeechNeeded() {
	lInfo.logln('check if relayedIfText2SpeechNeeded');
	try {
	var oParameterObject = JSON.parse(decode(raisedEvent.parameter.value));
	
	if (oParameterObject.action.type=='text2speech')
		if (oParameterObject.action.contentSrc==null) {
			if (raisedEvent.parameter.guid!=null) {
				oParameterObject.action.guid=raisedEvent.parameter.guid;
				oParameterObject.action.contentSrc=raisedEvent.parameter.url;
			} else {
				var oTempObject={};
				for (var sKey in raisedEvent.parameter)
					oTempObject[sKey]=raisedEvent.parameter[sKey];
				lInfo.logln('relaying event to sonos.cloud with parameter' + JSON.stringify(oTempObject));
				var oParameter=JSON.stringify({
						name:raisedEvent.name,
						parameter:raisedEvent.parameter});
				new Event('sonos.cloud',{
					actions:'createTextSound',
					voiceName:oParameterObject.action.voice_id,
					text:Utf8.encode((oParameterObject.action.text)),
					answerEvent:oParameter}).raise();
				return true;
			}
		}	
	} catch(e) {
		lWarn.logln(e);
	}
	return false;
}

if (raisedEvent.name == 'sonos.config') {
	Property.load();
    lInfo.logln("Sonos Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') 
	    if (!relayedIfText2SpeechNeeded()) {
	        lInfo.logln("Sonos Config param value " + decode(raisedEvent.parameter.value));
	        var success = storeValue(raisedEvent.parameter.value);
	        Property.store();
	        var evt;
	        if (success) {
	        	evt = new Event("sonos.saved", {actions:'config',complete:'success'});
	        } else {
	        	evt = new Event("sonos.saved", {actions:'config',complete:'failed'});
	        }
	        evt.raise();
	    	new Event('sonos.cloud',{actions:'cleanupTextSounds'}).raise();
	    }
	    
    if (raisedEvent.parameter.actions == 'saveMultiple') {
        lInfo.logln("Sonos Config param Array " + decode(raisedEvent.parameter.value));
        var oParameterArray = JSON.parse(decode(raisedEvent.parameter.value));
        var fSuccess=true;
        for (var iIndex=0;iIndex<oParameterArray.length;iIndex++) {
        	lInfo.logln("Sonos Config param Array # " + (iIndex+1));
            if (!storeValue(escape(JSON.stringify(oParameterArray[iIndex]))))
            	fSuccess=false;
        }
        Property.store();
        if (success) {
        	evt = new Event("sonos.saved", {actions:'config',complete:'success'});
        } else {
        	evt = new Event("sonos.saved", {actions:'config',complete:'failed'});
        }
        evt.raise();
    	new Event('sonos.cloud',{actions:'cleanupTextSounds'}).raise();
    }
    
    if (raisedEvent.parameter.actions == 'enable') {
        lInfo.logln("Sonos-Config enable value " + raisedEvent.parameter.id);

        var oIDObject=JSON.parse(decode(raisedEvent.parameter.id));
              
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
        	 lInfo.logln("Sonos-Config enable subvalue " + oIDObject[sKey] );
	        var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
	        if (sanityCheck != null) {                
	        	Property.setSavedProperty('entries/' + oIDObject[sKey] + '/conditions/enabled', true);
	        }
        }
        
        Property.store();
        var evt = new Event("sonos.saved", {actions:'enable',complete:'success'});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        lInfo.logln("Sonos-Config disable value " + raisedEvent.parameter.id);
        
        var oIDObject=JSON.parse(decode(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
	        var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
	        if (sanityCheck != null) {                
	        	Property.setSavedProperty('entries/' + oIDObject[sKey] + '/conditions/enabled', false);
	        }
        }
        
        Property.store();
        var evt = new Event("sonos.saved", {actions:'disable',complete:'success'});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("Sonos-Config delete value " + raisedEvent.parameter.id);
        
        var oIDObject=JSON.parse(decode(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
        	var baseNode = Property.getNode('entries');
	        if (baseNode != null) {
	            baseNode.removeChild(oIDObject[sKey]);
	            unregisterTrigger(baseNode.getPath() + "/" + oIDObject[sKey]);
	        }
        }

        Property.store();
        var evt = new Event("sonos.saved", {actions:'delete',complete:'success'});
        evt.raise();
    	new Event('sonos.cloud',{actions:'cleanupTextSounds'}).raise();
    }
    if (raisedEvent.parameter.actions == 'ensurePredefinedEntries') {
    	ensurePredefinedEntries();  
    	lInfo.logln('sonos.search-finished');
    	new Event('sonos.saved',{actions:'search',result:true}).raise();
		new Event('sonos.saved',{actions:'ensurePredefinedEntries'}).raise();
    }
    if (raisedEvent.parameter.actions == 'temporaryPlay') {
    	if (!relayedIfText2SpeechNeeded()) {
	    	var path=storeTemporaryValue(raisedEvent.parameter.value);
	    	if (path!=null) {
		    	new Event('sonos.execute',{path:path}).raise();
	    	}
	    	new Event("sonos.saved", {actions:'testPlay',complete:'success'}).raise();
	    }
    	
    }
}

if (raisedEvent.name=='running') {
	Property.load();
	ensurePredefinedEntries();
	if (Property.getNode('entries')!=null) {
		var oEntryArray=Property.getNode('entries').getChildren();
		for (var iIndex=0;iIndex<oEntryArray.length;iIndex++) {
			registerTrigger(oEntryArray[iIndex].getPath(),'sonos.execute',{});
		}
	}
	if (Property.getNode('special')!=null) {
		var oEntryArray=Property.getNode('special').getChildren();
		for (var iIndex=0;iIndex<oEntryArray.length;iIndex++) {
			registerTrigger(oEntryArray[iIndex].getPath(),oEntryArray[iIndex].getChild('eventName').getValue(),{});
		}
	}
	if (Property.getNode('restoreStatus')!=null) {
		registerTrigger('/scripts/sonos-controller/restoreStatus','sonos.execute.special',{actions:'restoreActualStatusAndGrouping'});
	}
	
}
